VERSION 4.00
Begin VB.Form FrmSubdir 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Search subdirectories"
   ClientHeight    =   4050
   ClientLeft      =   1785
   ClientTop       =   1950
   ClientWidth     =   7800
   Height          =   4515
   Icon            =   "SUBDIR.frx":0000
   Left            =   1725
   LinkTopic       =   "Form1"
   ScaleHeight     =   4050
   ScaleWidth      =   7800
   Top             =   1545
   Width           =   7920
   Begin VB.CommandButton StopBtn 
      Caption         =   "Stop"
      Enabled         =   0   'False
      Height          =   600
      Left            =   2895
      TabIndex        =   6
      Top             =   3195
      Width           =   1575
   End
   Begin VB.TextBox Filter 
      Alignment       =   1  'Right Justify
      Height          =   300
      Left            =   3240
      TabIndex        =   5
      Text            =   "*.BMP"
      Top             =   690
      Width           =   810
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   135
      TabIndex        =   3
      Top             =   570
      Width           =   2265
   End
   Begin VB.ListBox List1 
      BackColor       =   &H00FFFF00&
      Height          =   1230
      Left            =   2685
      Sorted          =   -1  'True
      TabIndex        =   2
      Top             =   1740
      Width           =   4845
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&Begin Search"
      Default         =   -1  'True
      Height          =   630
      Left            =   6060
      TabIndex        =   1
      Top             =   3195
      Width           =   1455
   End
   Begin VB.DirListBox Dir1 
      Height          =   2505
      Left            =   120
      TabIndex        =   0
      Top             =   930
      Width           =   2265
   End
   Begin VB.Label Label4 
      Caption         =   "Files found:"
      Height          =   240
      Left            =   2715
      TabIndex        =   9
      Top             =   1470
      Width           =   915
   End
   Begin VB.Label Label3 
      Caption         =   "Filter:"
      Height          =   210
      Left            =   2790
      TabIndex        =   8
      Top             =   720
      Width           =   645
   End
   Begin VB.Label Label2 
      Caption         =   "Look in:"
      Height          =   210
      Left            =   120
      TabIndex        =   7
      Top             =   330
      Width           =   1590
   End
   Begin VB.Label Label1 
      BackColor       =   &H00000000&
      BorderStyle     =   1  'Fixed Single
      ForeColor       =   &H00FFFFFF&
      Height          =   675
      Left            =   3660
      TabIndex        =   4
      Top             =   1050
      Visible         =   0   'False
      Width           =   3855
   End
End
Attribute VB_Name = "FrmSubdir"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Dim CancelSearch As Boolean

Sub SubDirFind(CurDirPath$, MyFilter$)
'''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  This Subroutine searches for all files matching    '
'  a given pattern (filter), beginning at a specific  '
'  directory or drive path.                           '
'                                                     '
'  Written by Bill Bercik 1995                        '
'                                                     '
'  Comment: Every damn programming class I've ever    '
'           taken, the professor always tries to      '
'           bust my balls on recursion and linked     '
'           lists.  Well, now after programming for   '
'           ten years I actually find myself using    '
'           recursion.  I still haven't had to use    '
'           frigging linked lists yet.  Maybe next    '
'           year.                                     '
'''''''''''''''''''''''''''''''''''''''''''''''''''''''

Dim DirsFound() As String 'List of Directories found
                          'at current path
   
'Add a backslash to the pathname if it is not already there
If (Right(CurDirPath$, 1) <> "\") Then
  CurDirPath$ = CurDirPath$ + "\"
End If

'Use the VB Dir function to find all the FILES in the
'current path that match the filter
MyFile$ = Dir(CurDirPath$ + MyFilter, vbNormal)
Do While (MyFile$ <> "")
  x% = DoEvents
  list1.AddItem CurDirPath$ + MyFile$
  MyFile$ = Dir()
  If CancelSearch = True Then
        Exit Sub
  End If
Loop

'Use the VB Dir function to find all the DIRECTORIES in the
'current path
MyDir$ = Dir(CurDirPath$, vbDirectory)
ReDim DirsFound(0)
Do While (MyDir$ <> "")
  x% = DoEvents
  If (MyDir$ <> ".") And (MyDir$ <> "..") Then
    If (GetAttr(CurDirPath$ & MyDir$) And vbDirectory) Then
      'Increment the size of the DirsFound array
      'and insert the new Directory that was found
      ReDim Preserve DirsFound(UBound(DirsFound) + 1)
      DirsFound(UBound(DirsFound)) = CurDirPath$ + MyDir$
      If CancelSearch = True Then
        Exit Sub
      End If
    End If
  End If
  MyDir$ = Dir()
Loop

'For each and every directory found in the current path,
'call myself
If UBound(DirsFound) > 0 Then
  For i = 1 To UBound(DirsFound)
    x% = DoEvents 'Free up some clock cycles to Windows
    Label1.Caption = "Now searching..." + vbCrLf + DirsFound(i) + vbCrLf + "Please Wait..."
    SubDirFind DirsFound(i), MyFilter$
  Next
End If
End Sub

Private Sub Command1_Click()

   'Please note that our listbox( List1) is more
   'than just a pretty widget. You can set its
   'visible property to false, and use it to store
   'the find list, much as people use linked lists .
   
   CurrentPath$ = Dir1.Path
   Command1.Enabled = False
   list1.Clear  'Clear the ListBox
   Label1.Visible = True
   CancelSearch = False 'Set Global Flag to false
                        'It is set by the Stop Button
   StopBtn.Enabled = True
   'Call our search function
   SubDirFind CurrentPath$, Trim(Filter.Text)
   Label1.Visible = False
   Command1.Enabled = True
 End Sub



Private Sub Drive1_Change()
Dir1.Path = Drive1.Drive    ' When drive changes, set directory path.
End Sub


Private Sub StopBtn_Click()
CancelSearch = True
End Sub


